From c180fe6d69ed032e0a9734da4548351e4ed4b4b3 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:39:00 +0000
Subject: [PATCH 8/51] add license block checks


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index b9d44f5..3de56fd 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -151,3 +151,40 @@ class ModuleMDLinter(object):
     def lint_description_ends_in_period(self):
         """The description SHOULD end in a period."""
         assert self.mmd.description.strip().endswith(".")
+
+    @error
+    @guidelines_link('#Module_licensing')
+    def lint_license_block_exists(self):
+        """Every module MUST contain a license block."""
+        assert 'license' in self.yaml_data
+
+    @error
+    @guidelines_link('#Module_licensing')
+    @detail("The license block must be a dictionary (key/value).")
+    def lint_license_block_keys(self):
+        """Every module MUST contain a license block."""
+        assert isinstance(self.yaml_data['license'], dict)
+
+    @error
+    @guidelines_link('#Module_licensing')
+    @detail("The module license block must exist.")
+    def lint_license_module_block_exists(self):
+        """Every module MUST contain a license block and declare a list of
+        the module's licenses."""
+        assert 'module' in self.yaml_data['license']
+
+    @error
+    @guidelines_link('#Module_licensing')
+    @detail("The module license block must be a list.")
+    def lint_license_module_block_is_list(self):
+        """Every module MUST contain a license block and declare a list of
+        the module's licenses."""
+        assert isinstance(self.yaml_data['license']['module'], list)
+
+    @error
+    @guidelines_link('#Module_licensing')
+    @detail("The content license block must be a list if it exists.")
+    def lint_license_content(self):
+        """The packager MAY also define a list of content licenses."""
+        if 'content' in self.yaml_data['license']:
+            assert isinstance(self.yaml_data['license']['content'], list)

